// ILVideo80Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "ILVideo80.h"
#include "ILVideo80Dlg.h"
#include "IlSetup.h"
#include "TcpIp.h"
#include "Vid80Dev.h"

#define VERSION   "1.31"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CILVideo80App theApp;

#ifdef _DEBUG
LPCTSTR szNoTitle = _T("ILVideo80 ")_T(VERSION)_T(" Debug");
#else
LPCTSTR szNoTitle = _T("ILVideo80 ")_T(VERSION);
#endif

static const LPCTSTR szLicence =
	_T("This program is free software; you can redistribute it and/or modify\r\n")
	_T("it under the terms of the GNU General Public License as published by\r\n")
	_T("the Free Software Foundation; either version 2 of the License, or\r\n")
	_T("(at your option) any later version.\r\n")
	_T("\r\n")
	_T("This program is distributed in the hope that it will be useful,\r\n")
	_T("but WITHOUT ANY WARRANTY; without even the implied warranty of\r\n")
	_T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\r\n")
	_T("See the GNU General Public License for more details.\r\n")
	_T("\r\n")
	_T("You should have received a copy of the GNU General Public License along\r\n")
	_T("with this program; if not, write to the Free Software Foundation, Inc.,\r\n")
	_T("51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.");

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_VERSION,szNoTitle);
	SetDlgItemText(IDC_LICENSE,szLicence);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CILVideo80Dlg dialog

CILVideo80Dlg::CILVideo80Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CILVideo80Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CILVideo80Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	VERIFY(m_hAccelTable = LoadAccelerators(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME)));

	m_strAddrOut = _T("localhost");
	m_uPortOut   = 60000;
	m_uPortIn    = 60001;

	m_dwConnectTimeout = 0xFFFFFFFF;			// client connect timeout in us (default blocked connect timeout)

	// default color settings
	m_mc.rgbTextColorBW = RGB(255,255,255);		// B&W text color
	m_mc.rgbBkColorBW   = RGB(0,0,0);			// B&W background color
	
	m_mc.rgbTextColorGreen = RGB(27,200,72);	// green text color
	m_mc.rgbBkColorGreen   = RGB(34,60,25);		// green background color

	m_mc.rgbTextColorAmber = RGB(243,153,101);	// amber text color
	m_mc.rgbBkColorAmber   = RGB(87,47,55);		// amber background color

	m_mc.rgbTextColorCustom = RGB(0,0,0);		// custom text color
	m_mc.rgbBkColorCustom   = RGB(255,255,255);	// custom background color

	// the default setting
	m_mc.rgbTextColor = m_mc.rgbTextColorBW;	// white text color
	m_mc.rgbBkColor   = m_mc.rgbBkColorBW;		// black background color

	m_pComObj = NULL;
	m_pVidDev = NULL;
}

CILVideo80Dlg::~CILVideo80Dlg()
{
	delete m_pVidDev;						// delete video device
}

/////////////////////////////////////////////////////////////////////////////
// CILVideo80Dlg settings helper functions

CString CILVideo80Dlg::ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR cBuffer[1024];

		::GetPrivateProfileString(lpszSection,lpszEntry,lpszDefault,cBuffer,ARRAYSIZEOF(cBuffer),theApp.m_szIniFile);
		return CString(cBuffer);
	}
	else
	{
		return AfxGetApp()->GetProfileString(lpszSection,lpszEntry,lpszDefault);
	}
}

UINT CILVideo80Dlg::ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::GetPrivateProfileInt(lpszSection,lpszEntry,nDefault,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->GetProfileInt(lpszSection,lpszEntry,nDefault);
	}
}

BOOL CILVideo80Dlg::WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		return ::WritePrivateProfileString(lpszSection,lpszEntry,lpszValue,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileString(lpszSection,lpszEntry,lpszValue);
	}
}

BOOL CILVideo80Dlg::WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue)
{
	if (*theApp.m_szIniFile != 0)
	{
		TCHAR s[16];
		wsprintf(s,_T("%i"),nValue);
		return ::WritePrivateProfileString(lpszSection,lpszEntry,s,theApp.m_szIniFile);
	}
	else
	{
		return AfxGetApp()->WriteProfileInt(lpszSection,lpszEntry,nValue);
	}
}

void CILVideo80Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CILVideo80Dlg)
	DDX_Control(pDX, IDC_STOP, m_CButStop);
	DDX_Control(pDX, IDC_START, m_CButStart);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CILVideo80Dlg, CDialog)
	ON_MESSAGE(WM_INTERFACESTOPPED, OnInterfaceStopped)

	//{{AFX_MSG_MAP(CILVideo80Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CILVideo80Dlg message handlers

BOOL CILVideo80Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "&Copy Screen\tCtrl+C", "TCP/IP Setup...", "Monitor Type Setup...",
	// "Help Topics..." and "About ILVideo80..." menu items to the system menu.

	// IDM_COPYSCREEN must be in the system command range.
	ASSERT((IDM_COPYSCREEN & 0xFFF0) == IDM_COPYSCREEN);
	ASSERT(IDM_COPYSCREEN < 0xF000);

	// IDM_HPILSETUP must be in the system command range.
	ASSERT((IDM_HPILSETUP & 0xFFF0) == IDM_HPILSETUP);
	ASSERT(IDM_HPILSETUP < 0xF000);

	// IDM_MONSETUP must be in the system command range.
	ASSERT((IDM_MONSETUP & 0xFFF0) == IDM_MONSETUP);
	ASSERT(IDM_MONSETUP < 0xF000);

	// IDM_HELPTOPICS must be in the system command range.
	ASSERT((IDM_HELPTOPICS & 0xFFF0) == IDM_HELPTOPICS);
	ASSERT(IDM_HELPTOPICS < 0xF000);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strText;
		pSysMenu->AppendMenu(MF_SEPARATOR);

		strText.LoadString(IDS_COPYSCREEN);
		pSysMenu->AppendMenu(MF_STRING, IDM_COPYSCREEN, strText);

		strText.LoadString(IDS_TCPIP_SETTING);
		pSysMenu->AppendMenu(MF_STRING, IDM_HPILSETUP, strText);

		strText.LoadString(IDS_MON_SETTING);
		pSysMenu->AppendMenu(MF_STRING, IDM_MONSETUP, strText);

		strText.LoadString(IDS_HELP_TOPICS);
		pSysMenu->AppendMenu(MF_STRING, IDM_HELPTOPICS, strText);

		strText.LoadString(IDS_ABOUTBOX);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strText);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_CButStart.EnableWindow(TRUE);
	m_CButStop.EnableWindow(FALSE);

	if (*theApp.m_szIniFile != 0)			// ini file given
	{
		CString strTitle,strAppTitle;

		// new document title
		GetWindowText(strAppTitle);
		strTitle.Format(_T("%s - %s"),strAppTitle,theApp.m_lpFilePart);
		SetWindowText(strTitle);			// set document title with ini file
	}

	GetDlgItem(IDC_STATIC_VIDEO)->SetFont(CFont::FromHandle((HFONT)GetStockObject(DEFAULT_GUI_FONT)),FALSE);
	GetDlgItem(IDC_START)       ->SetFont(CFont::FromHandle((HFONT)GetStockObject(DEFAULT_GUI_FONT)),FALSE);
	GetDlgItem(IDC_STOP)        ->SetFont(CFont::FromHandle((HFONT)GetStockObject(DEFAULT_GUI_FONT)),FALSE);
	GetDlgItem(IDCANCEL)        ->SetFont(CFont::FromHandle((HFONT)GetStockObject(DEFAULT_GUI_FONT)),FALSE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);

	// load positions from registry if available
	m_nPosX      = ReadInt(_T("Settings"),_T("WinPosX"),wndpl.rcNormalPosition.left);
	m_nPosY      = ReadInt(_T("Settings"),_T("WinPosY"),wndpl.rcNormalPosition.top);

	// TCP/IP settings
	m_strAddrOut = ReadString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	m_uPortOut   = ReadInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	m_uPortIn    = ReadInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	m_dwConnectTimeout = ReadInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	LoadMonColorSettings();					// video device color settings
	SetWindowLocation(m_nPosX,m_nPosY);		// set windows location

	m_nCols = 80;							// no. of visible columns
	m_nRows = 24;							// no. of visible rows

	// subclass terminal window with owner drawing
	m_wndTerm.SubclassDlgItem(IDC_TEXT,this);
	m_wndTerm.SetColors(m_mc.rgbTextColor,m_mc.rgbBkColor);

	// create the video instrument class
	m_pVidDev = new CVid80Dev(m_wndTerm,m_nCols,m_nRows);

	UpdateData(FALSE);

	// press the "Start" button
	if (theApp.m_bStart) PostMessage(WM_COMMAND,IDC_START);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CILVideo80Dlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (m_hAccelTable)
	{
		if (::TranslateAccelerator(m_hWnd, m_hAccelTable, pMsg))
		{
			return TRUE;
		}
	}
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		return TRUE;  // disable the ESC key quitting the application
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CILVideo80Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	switch (nID & 0xFFF0)
	{
	case IDM_COPYSCREEN:
		CopyScreenToClipboard();
		break;
	case IDM_HPILSETUP:
	{
		CILSetup dlg(m_strAddrOut,m_uPortOut,m_uPortIn);
		if (IDOK == dlg.DoModal())
		{
			dlg.GetData(m_strAddrOut,m_uPortOut,m_uPortIn);
		}
		break;
	}
	case IDM_MONSETUP:
	{
		CMonSetup dlg(m_mc);
		if (IDOK == dlg.DoModal())
		{
			m_wndTerm.SetColors(m_mc.rgbTextColor,m_mc.rgbBkColor);
			Invalidate();
		}
		break;
	}
	case IDM_HELPTOPICS:
		ShellExecute(GetSafeHwnd(),
					 _T("open"),
					 _T("ILVideo80.htm"),
					 NULL,
					 _T(""),
					 SW_SHOWNORMAL);
		break;
	case IDM_ABOUTBOX:
		CAboutDlg().DoModal();
		break;
	default:
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CILVideo80Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		// fill rectangle around text area to simulate
		// the non writeable borders of a tube monitor
		CWnd *pWnd = GetDlgItem(IDC_BORDER);

		CPaintDC dc(pWnd);
		RECT rc;
		pWnd->GetClientRect(&rc);			// get area dimension
		dc.FillSolidRect(&rc,m_mc.rgbBkColor);	// fill area with background color
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CILVideo80Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// set window location
void CILVideo80Dlg::SetWindowLocation(INT nPosX,INT nPosY)
{
	WINDOWPLACEMENT wndpl;
	RECT *pRc = &wndpl.rcNormalPosition;

	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	pRc->right = pRc->right - pRc->left + nPosX;
	pRc->bottom = pRc->bottom - pRc->top + nPosY;
	pRc->left = nPosX;
	pRc->top = nPosY;
	SetWindowPlacement(&wndpl);
	return;
}

void CILVideo80Dlg::LoadMonColorSettings()
{
	// predefined video device color settings
	m_mc.rgbTextColorBW     = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("TextBW"),m_mc.rgbTextColorBW));
	m_mc.rgbBkColorBW       = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("BkBW"),m_mc.rgbBkColorBW));
	m_mc.rgbTextColorGreen  = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("TextGreen"),m_mc.rgbTextColorGreen));
	m_mc.rgbBkColorGreen    = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("BkGreen"),m_mc.rgbBkColorGreen));
	m_mc.rgbTextColorAmber  = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("TextAmber"),m_mc.rgbTextColorAmber));
	m_mc.rgbBkColorAmber    = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("BkAmber"),m_mc.rgbBkColorAmber));
	m_mc.rgbTextColorCustom = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("TextCustom"),m_mc.rgbTextColorCustom));
	m_mc.rgbBkColorCustom   = static_cast<COLORREF>(ReadInt(_T("Colors"),_T("BkCustom"),m_mc.rgbBkColorCustom));

	// video device color settings
	m_mc.rgbTextColor = static_cast<COLORREF>(ReadInt(_T("Settings"),_T("ColorText"),m_mc.rgbTextColor));
	m_mc.rgbBkColor   = static_cast<COLORREF>(ReadInt(_T("Settings"),_T("ColorBackground"),m_mc.rgbBkColor));
	return;
}

void CILVideo80Dlg::SaveMonColorSettings()
{
	// predefined video device color settings
	WriteInt(_T("Colors"),_T("TextBW"),static_cast<INT>(m_mc.rgbTextColorBW));
	WriteInt(_T("Colors"),_T("BkBW"),static_cast<INT>(m_mc.rgbBkColorBW));
	WriteInt(_T("Colors"),_T("TextGreen"),static_cast<INT>(m_mc.rgbTextColorGreen));
	WriteInt(_T("Colors"),_T("BkGreen"),static_cast<INT>(m_mc.rgbBkColorGreen));
	WriteInt(_T("Colors"),_T("TextAmber"),static_cast<INT>(m_mc.rgbTextColorAmber));
	WriteInt(_T("Colors"),_T("BkAmber"),static_cast<INT>(m_mc.rgbBkColorAmber));
	WriteInt(_T("Colors"),_T("TextCustom"),static_cast<INT>(m_mc.rgbTextColorCustom));
	WriteInt(_T("Colors"),_T("BkCustom"),static_cast<INT>(m_mc.rgbBkColorCustom));

	// video device color settings
	WriteInt(_T("Settings"),_T("ColorText"),static_cast<INT>(m_mc.rgbTextColor));
	WriteInt(_T("Settings"),_T("ColorBackground"),static_cast<INT>(m_mc.rgbBkColor));
	return;
}

void CILVideo80Dlg::CopyScreenToClipboard()
{
	if (OpenClipboard())
	{
		if (EmptyClipboard())
		{
			m_wndTerm.FlushText();			// flush buffered text

			// copy CF_TEXT to Clipboard
			{
				HANDLE hClipObj;
				LPTSTR lpszData;

				INT nLength = m_wndTerm.GetWindowTextLength();
				
				// allocate clipboard data
				if ((hClipObj = GlobalAlloc(GMEM_MOVEABLE,(nLength + 1) * sizeof(*lpszData))) != NULL)
				{
					if ((lpszData = (LPTSTR) GlobalLock(hClipObj)))
					{
						m_wndTerm.GetWindowText(lpszData,nLength + 1);

						for (INT i = 0; i < nLength; ++i)
						{
							// the original buffer only contain ASCII characters from the interface
							ASSERT(lpszData[i] < 256);

							if (m_wndTerm.GetAsciiMode())
							{
								// clear inverse color bit
								lpszData[i] &= 0x7F;
							}
							else
							{
								// translate into Roman8 Unicode character
								lpszData[i] = static_cast<TCHAR>(CStaticTerm::GetRoman8Char(static_cast<BYTE>(lpszData[i])));
							}
						}
						GlobalUnlock(hClipObj);

						#if defined _UNICODE
							SetClipboardData(CF_UNICODETEXT,hClipObj);
						#else
							SetClipboardData(CF_TEXT,hClipObj);
						#endif
					}
				}
			}

			// copy CF_BITMAP to Clipboard
			{
				CWnd *pWnd = &m_wndTerm;
				CWindowDC dc(pWnd);
				CDC memDC;

				if (memDC.CreateCompatibleDC(&dc))
				{
					CBitmap bmpImage;
					CRect   rect;

					pWnd->GetWindowRect(rect);
					if (bmpImage.CreateCompatibleBitmap(&dc,rect.Width(),rect.Height()))
					{
						CBitmap *pOldBitmap = memDC.SelectObject(&bmpImage);

						// copy
						if (memDC.BitBlt(0,0,rect.Width(),rect.Height(),&dc,0,0,SRCCOPY))
						{
							// get handle to GDI object and hand over to Clipboard
							SetClipboardData(CF_BITMAP,bmpImage.GetSafeHandle());
						}

						// clean up
						memDC.SelectObject(pOldBitmap);

						// detach the Windows GDI object from a CBitmap object
						bmpImage.Detach();
					}
				}
			}
		}
		CloseClipboard();
	}
	return;
}

void CILVideo80Dlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	m_pComObj = new CTcpIp(m_pVidDev,m_strAddrOut,m_uPortOut,m_uPortIn,m_dwConnectTimeout,this);
	if (m_pComObj != NULL)
	{
		if (m_pComObj->StartServer() == true) // init server
		{
			m_CButStart.SetButtonStyle(BS_PUSHBUTTON);
			m_CButStart.EnableWindow(FALSE);
			m_CButStop.EnableWindow(TRUE);
			m_CButStop.SetButtonStyle(BS_DEFPUSHBUTTON);
			m_CButStop.SetFocus();
		}
		else								// error
		{
			ASSERT(m_pComObj);				// free Interface class
			delete m_pComObj;
			m_pComObj = NULL;
		}
	}
}

void CILVideo80Dlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	ASSERT(m_pComObj != NULL);
	m_pComObj->StopServer();				// quit server thread
}

LRESULT CILVideo80Dlg::OnInterfaceStopped(WPARAM wParam,LPARAM lParam)
{
	// quit message from Interface worker thread
	CInterface *pComObj = reinterpret_cast<CInterface *>(wParam);
	ASSERT(pComObj == m_pComObj);

	ASSERT(m_pComObj);
	delete m_pComObj;
	m_pComObj = NULL;

	m_CButStop.SetButtonStyle(BS_PUSHBUTTON);
	m_CButStop.EnableWindow(FALSE);
	m_CButStart.EnableWindow(TRUE);
	m_CButStart.SetButtonStyle(BS_DEFPUSHBUTTON);
	m_CButStart.SetFocus();
	return 0;
	UNREFERENCED_PARAMETER(wParam);
	UNREFERENCED_PARAMETER(lParam);
}

void CILVideo80Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if (m_pComObj != NULL)					// Interface running
	{
		OnStop();
		PostMessage(WM_COMMAND,IDCANCEL,0);	// call myself, until thread finished
		return;
	}

	// save current settings
	UpdateData(TRUE);

	// get actual window position
	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(wndpl);
	GetWindowPlacement(&wndpl);
	m_nPosX = wndpl.rcNormalPosition.left;
	m_nPosY = wndpl.rcNormalPosition.top;

	TCHAR szAppFile[_MAX_PATH];				// full pathname of application
	GetModuleFileName(NULL,szAppFile,ARRAYSIZEOF(szAppFile));
	WriteString(_T("Run"),_T("App"),szAppFile);

	WriteInt(_T("Settings"),_T("WinPosX"),m_nPosX);
	WriteInt(_T("Settings"),_T("WinPosY"),m_nPosY);

	// TCP/IP settings
	WriteString(_T("Settings"),_T("AddrOut"),m_strAddrOut);
	WriteInt(_T("Settings"),_T("PortOut"),m_uPortOut);
	WriteInt(_T("Settings"),_T("PortIn"),m_uPortIn);
	WriteInt(_T("Settings"),_T("ConnectTimeout"),m_dwConnectTimeout);

	SaveMonColorSettings();					// video device color settings

	CDialog::OnCancel();
}
