// ILVideo80Dlg.h : header file
//

#if !defined(AFX_ILVIDEO80DLG_H__A02EE744_1795_4C06_AF17_D8E6F8172223__INCLUDED_)
#define AFX_ILVIDEO80DLG_H__A02EE744_1795_4C06_AF17_D8E6F8172223__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MonSetup.h"
#include "StaticTerm.h"

class CInterface;							// interface object class
class CVid80Dev;							// the video display

/////////////////////////////////////////////////////////////////////////////
// CILVideo80Dlg dialog

class CILVideo80Dlg : public CDialog
{
// Construction
public:
	CILVideo80Dlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CILVideo80Dlg();

// Dialog Data
	//{{AFX_DATA(CILVideo80Dlg)
	enum { IDD = IDD_ILVIDEO80_DIALOG };
	CButton	m_CButStop;
	CButton	m_CButStart;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CILVideo80Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	LRESULT OnInterfaceStopped(WPARAM wParam, LPARAM lParam);

	// Generated message map functions
	//{{AFX_MSG(CILVideo80Dlg)
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStart();
	afx_msg void OnStop();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	LONG    m_nPosX;						// display position
	LONG    m_nPosY;

	CString m_strAddrOut;
	UINT    m_uPortIn;
	UINT    m_uPortOut;
	DWORD   m_dwConnectTimeout;				// client connect timeout

	HACCEL  m_hAccelTable;

	MONITORCOL  m_mc;						// default monitor colors

	CStaticTerm m_wndTerm;					// subclassed terminal window

	INT m_nCols;							// no. of visible columns
	INT m_nRows;							// no. of visible rows

	CInterface *m_pComObj;					// interface object class
	CVid80Dev  *m_pVidDev;					// the video display

	CString ReadString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault);
	UINT    ReadInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nDefault);
	BOOL    WriteString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue);
	BOOL    WriteInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, INT nValue);

	void SetWindowLocation(INT nPosX, INT nPosY);
	void LoadMonColorSettings();
	void SaveMonColorSettings();
	void CopyScreenToClipboard();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ILVIDEO80DLG_H__A02EE744_1795_4C06_AF17_D8E6F8172223__INCLUDED_)
