// MonSetup.cpp : implementation file
//

#include "stdafx.h"
#include "ilvideo80.h"
#include "MonSetup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMonSetup dialog

CMonSetup::CMonSetup(MONITORCOL& mc, CWnd* pParent /*=NULL*/)
	: m_mcInit(mc), CDialog(CMonSetup::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMonSetup)
	m_nMonType = -1;
	m_nColFgRed = 0;
	m_nColFgGreen = 0;
	m_nColFgBlue = 0;
	m_nColBgRed = 0;
	m_nColBgGreen = 0;
	m_nColBgBlue = 0;
	//}}AFX_DATA_INIT

	m_mc = m_mcInit;						// create a working copy of monitor color stucture
}

void CMonSetup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonSetup)
	DDX_Radio(pDX, IDC_COL_BW, m_nMonType);
	DDX_Text(pDX, IDC_COL_F_RED, m_nColFgRed);
	DDV_MinMaxInt(pDX, m_nColFgRed, 0, 255);
	DDX_Text(pDX, IDC_COL_F_GREEN, m_nColFgGreen);
	DDV_MinMaxInt(pDX, m_nColFgGreen, 0, 255);
	DDX_Text(pDX, IDC_COL_F_BLUE, m_nColFgBlue);
	DDV_MinMaxInt(pDX, m_nColFgBlue, 0, 255);
	DDX_Text(pDX, IDC_COL_B_RED, m_nColBgRed);
	DDV_MinMaxInt(pDX, m_nColBgRed, 0, 255);
	DDX_Text(pDX, IDC_COL_B_GREEN, m_nColBgGreen);
	DDV_MinMaxInt(pDX, m_nColBgGreen, 0, 255);
	DDX_Text(pDX, IDC_COL_B_BLUE, m_nColBgBlue);
	DDV_MinMaxInt(pDX, m_nColBgBlue, 0, 255);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMonSetup, CDialog)
	//{{AFX_MSG_MAP(CMonSetup)
	ON_BN_CLICKED(IDC_COL_BW, OnColBw)
	ON_BN_CLICKED(IDC_COL_GREEN, OnColGreen)
	ON_BN_CLICKED(IDC_COL_AMBER, OnColAmber)
	ON_BN_CLICKED(IDC_COL_CUSTOM, OnColCustom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonSetup message handlers

BOOL CMonSetup::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	WriteEditCtrl();						// write actual colors to edit controls
	CheckForMonType();						// set the radio button

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}

void CMonSetup::OnColBw() 
{
	// TODO: Add your control notification handler code here
	SetNewColor(m_mc.rgbTextColorBW,m_mc.rgbBkColorBW,FALSE);
}

void CMonSetup::OnColGreen() 
{
	// TODO: Add your control notification handler code here
	SetNewColor(m_mc.rgbTextColorGreen,m_mc.rgbBkColorGreen,FALSE);
}

void CMonSetup::OnColAmber() 
{
	// TODO: Add your control notification handler code here
	SetNewColor(m_mc.rgbTextColorAmber,m_mc.rgbBkColorAmber,FALSE);
}

void CMonSetup::OnColCustom() 
{
	// TODO: Add your control notification handler code here
	SetNewColor(m_mc.rgbTextColorCustom,m_mc.rgbBkColorCustom,TRUE);
}

void CMonSetup::OnOK() 
{
	// TODO: Add extra validation here
	ReadEditCtrl();							// read actual color settings
	m_mcInit = m_mc;						// write working copy back to initial structure
	CDialog::OnOK();
}

VOID CMonSetup::WriteEditCtrl()
{
	UpdateData(TRUE);
	m_nColFgRed = GetRValue(m_mc.rgbTextColor);
	m_nColFgGreen = GetGValue(m_mc.rgbTextColor);
	m_nColFgBlue = GetBValue(m_mc.rgbTextColor);
	m_nColBgRed = GetRValue(m_mc.rgbBkColor);
	m_nColBgGreen = GetGValue(m_mc.rgbBkColor);
	m_nColBgBlue = GetBValue(m_mc.rgbBkColor);
	UpdateData(FALSE);
	return;
}

VOID CMonSetup::ReadEditCtrl()
{
	UpdateData(TRUE);
	m_mc.rgbTextColor = RGB(m_nColFgRed,m_nColFgGreen,m_nColFgBlue);
	m_mc.rgbBkColor = RGB(m_nColBgRed,m_nColBgGreen,m_nColBgBlue);
	return;
}

VOID CMonSetup::EnableColorEdit(BOOL bEnable)
{
	GetDlgItem(IDC_COL_F_RED)->EnableWindow(bEnable);
	GetDlgItem(IDC_COL_F_GREEN)->EnableWindow(bEnable);
	GetDlgItem(IDC_COL_F_BLUE)->EnableWindow(bEnable);
	GetDlgItem(IDC_COL_B_RED)->EnableWindow(bEnable);
	GetDlgItem(IDC_COL_B_GREEN)->EnableWindow(bEnable);
	GetDlgItem(IDC_COL_B_BLUE)->EnableWindow(bEnable);
	return;
}

VOID CMonSetup::CheckForMonType()
{
	do
	{
		// check for B&W default colors
		if (   m_mc.rgbTextColorBW == m_mc.rgbTextColor
			&& m_mc.rgbBkColorBW   == m_mc.rgbBkColor)
		{
			m_nMonType = 0;
			break;
		}

		// check for green default colors
		if (   m_mc.rgbTextColorGreen == m_mc.rgbTextColor
			&& m_mc.rgbBkColorGreen   == m_mc.rgbBkColor)
		{
			m_nMonType = 1;
			break;
		}

		// check for amber default colors
		if (   m_mc.rgbTextColorAmber == m_mc.rgbTextColor
			&& m_mc.rgbBkColorAmber   == m_mc.rgbBkColor)
		{
			m_nMonType = 2;
			break;
		}

		// custom colors
		m_mc.rgbTextColorCustom = m_mc.rgbTextColor;
		m_mc.rgbBkColorCustom   = m_mc.rgbBkColor;
		m_nMonType = 3;
	}
	while (false);

	EnableColorEdit(m_nMonType == 3);		// enable on custom color
	return;
}

VOID CMonSetup::SetNewColor(COLORREF rgbTextColor,COLORREF rgbBkColor, BOOL bEnable)
{
	if (m_nMonType == 3)					// save last settings from custom control
	{
		ReadEditCtrl();
		m_mc.rgbTextColorCustom = m_mc.rgbTextColor;
		m_mc.rgbBkColorCustom   = m_mc.rgbBkColor;
	}

	m_mc.rgbTextColor = rgbTextColor;		// text color
	m_mc.rgbBkColor   = rgbBkColor;			// background color

	WriteEditCtrl();
	EnableColorEdit(bEnable);
	return;
}
