#if !defined(AFX_MONSETUP_H__B086DF3F_4829_4F68_A013_CF5A3BA6E1C8__INCLUDED_)
#define AFX_MONSETUP_H__B086DF3F_4829_4F68_A013_CF5A3BA6E1C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonSetup.h : header file
//

typedef struct _MONITORCOL
{
	COLORREF rgbTextColorBW;				// B&W text color
	COLORREF rgbBkColorBW;					// B&W background color
	
	COLORREF rgbTextColorGreen;				// green text color
	COLORREF rgbBkColorGreen; 				// green background color

	COLORREF rgbTextColorAmber;				// amber text color
	COLORREF rgbBkColorAmber; 				// amber background color

	COLORREF rgbTextColorCustom;			// custom text color
	COLORREF rgbBkColorCustom;				// custom background color

	COLORREF rgbTextColor;					// actual text color
	COLORREF rgbBkColor;					// actual background color
} MONITORCOL;

/////////////////////////////////////////////////////////////////////////////
// CMonSetup dialog

class CMonSetup : public CDialog
{
// Construction
public:
	CMonSetup(MONITORCOL& mc, CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CMonSetup)
	enum { IDD = IDD_MON_SETTING };
	int 	m_nMonType;
	int 	m_nColFgBlue;
	int 	m_nColFgGreen;
	int 	m_nColFgRed;
	int 	m_nColBgBlue;
	int 	m_nColBgGreen;
	int 	m_nColBgRed;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonSetup)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMonSetup)
	virtual BOOL OnInitDialog();
	afx_msg void OnColBw();
	afx_msg void OnColGreen();
	afx_msg void OnColAmber();
	afx_msg void OnColCustom();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	MONITORCOL& m_mcInit;					// initial monitor color settings
	MONITORCOL  m_mc;						// working copy of the monitor color settings

	VOID WriteEditCtrl();
	VOID ReadEditCtrl();
	VOID EnableColorEdit(BOOL bEnable);
	VOID CheckForMonType();
	VOID SetNewColor(COLORREF rgbTextColor,COLORREF rgbBkColor,BOOL bEnable);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONSETUP_H__B086DF3F_4829_4F68_A013_CF5A3BA6E1C8__INCLUDED_)
