#if !defined(AFX_STATICTERM_H__53B59095_37CC_4819_BAAB_558042062120__INCLUDED_)
#define AFX_STATICTERM_H__53B59095_37CC_4819_BAAB_558042062120__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StaticTerm.h : header file
//

enum CUR_STATE { CUR_OFF, CUR_REPLACE, CUR_INSERT };

/////////////////////////////////////////////////////////////////////////////
// CStaticTerm window

class CStaticTerm : public CStatic
{
	DECLARE_DYNAMIC(CStaticTerm)

// Construction
public:
	CStaticTerm(INT nCols = 80,INT nRows = 24,DWORD dwRefresh = 30);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticTerm)
	protected:
	virtual void DrawItem(LPDRAWITEMSTRUCT /*lpDrawItemStruct*/);
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

#if _MSC_VER <= 1200 // MSVC6 and earlier
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
#endif

// Implementation
public:
	virtual ~CStaticTerm();

	INT  GetCols() { return m_nCols; }
	INT  GetRows() { return m_nRows; }

	static WCHAR GetRoman8Char(BYTE byAsciiChar);

	VOID SetColors(COLORREF rgbTextColor, COLORREF rgbBkColor);
	VOID SetAsciiMode(bool bASCII = true);
	bool GetAsciiMode() { return m_bASCII; }
	VOID SetSize(INT nCols,INT nRows);
	VOID SetCursor(INT x, INT y, enum CUR_STATE eState);
	VOID SetBufferText(LPCTSTR lpszText);
	VOID FlushText();

	// Generated message map functions
protected:
	//{{AFX_MSG(CStaticTerm)
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

private:
	static const WCHAR wcRoman8[];			// Roman 8 to Unicode

	CBitmap  m_BmpMonChars;					// bitmap with monitor characters
	INT      m_nMonChrWidth;				// monitor character width
	INT      m_nMonChrHeight;				// monitor character height

	COLORREF m_rgbTextColor;				// text color
	COLORREF m_rgbBkColor;					// background color

	HANDLE   m_hWorkerThread;				// cursor blinking thread
	enum CUR_STATE m_eCurState;				// current blinking state

	CFont    m_Font40;						// 40x20 font without antialiasing
	CFont    m_Font80;						// 80x24 font without antialiasing

	bool     m_bASCII;						// ASCII/Roman-8 character set

	INT      m_nCols;						// no. of visible columns
	INT      m_nRows;						// no. of visible rows

	INT      m_nWidth;						// character width
	INT      m_nHeight;						// character height

	INT      m_xCurPos; 					// actual x cursor position
	INT      m_yCurPos; 					// actual y cursor position

	HANDLE   m_hEvent;						// event stop blinking

	INT      m_nBlinkFreq;					// blink frequency in ms
	bool     m_bCursorAct;					// cursor active

	CRITICAL_SECTION m_csLock;				// lock for access drawing buffer
	CString m_strBuffer;					// intermediate drawing buffer
	HANDLE  m_hDrawThread;					// drawing thread
	bool    m_bRunning;						// drawing thread running
	HANDLE  m_hDrawEvent;					// event to start drawing timer
	DWORD   m_dwRefresh;					// output refresh time in ms

	// cursor blinking thread
	VOID InvalidateCursor();
	static UINT ThreadCusorBlink(LPVOID pParam);
	bool StartBlinkingThread();
	VOID StopBlinkingThread();

	// drawing thread
	static UINT DrawThread(LPVOID pParam);
	bool StartDrawWorker();
	VOID StopDrawWorker();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STATICTERM_H__53B59095_37CC_4819_BAAB_558042062120__INCLUDED_)
