// Vid80Dev.h: interface for the CVid80Dev class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VID80DEV_H__72768E03_9B5A_461F_8EAA_BB38880F307A__INCLUDED_)
#define AFX_VID80DEV_H__72768E03_9B5A_461F_8EAA_BB38880F307A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IldevBase.h"
#include "StaticTerm.h"

class CVid80Dev : public CIldevBase
{
public:
	CVid80Dev(CStaticTerm& wndScreen,INT nCols,INT nRows);
	virtual ~CVid80Dev();

private:
	// video emulation
	CStaticTerm& m_wndScreen;				// screen buffer

	INT  m_nVisCols;						// no. of visible columns
	INT  m_nVisRows;						// no. of visible rows

	BYTE *m_pbyBuffer;						// video buffer
	BYTE *m_pbyAutoCrLf;					// auto CR LF in video buffer line

	INT  m_nBufRows;						// no. of buffer rows
	INT  m_nBufLine;						// buffer line of screen view

	INT  m_xCurPos;							// actual x cursor position
	INT  m_yCurPos;							// actual y cursor position

	bool m_bPal;							// NTSC/PAL mode
	bool m_bMonitorMode;					// monitor mode enabled
	bool m_bInsertMode;						// insert character mode

	bool m_bCursorShow; 					// show cursor
	enum CUR_STATE m_eCurState;				// actual cursor state

	INT  m_nEsc;							// escape sequence
	INT  m_nEscCol;							// column argument of set cursor position
	bool m_bAutoCrLf;						// evaluated automatic CR LF

	BYTE GetILStatus(WORD& wStatus);		// update HP-IL status information

	VOID SyncScreen();
	VOID Resize(INT cx, INT cy);
	VOID SetCursorPos(INT x, INT y);
	VOID CursorLeft();
	VOID CursorRight();
	VOID InsertLine();
	VOID DeleteLine();
	VOID InsertChar(BYTE byData);
	VOID DeleteChar();
	VOID EvalLF();
	VOID SoftReset();

	VOID ClearDevice() override;			// clear device
	VOID InData(WORD wFrame) override;		// listener transfer
};

#endif // !defined(AFX_VID80DEV_H__72768E03_9B5A_461F_8EAA_BB38880F307A__INCLUDED_)
